<?php
class App {
    
    /* Контроллер по умолчанию */
    protected $controller = 'home';
    protected $method = 'index';
    protected $params = array();
    
    public function __construct() {
        $url = $this->parseUrl();
        
        //print_r($url);
        
        /* проверяем на наличие контроллера*/
        if (file_exists('../app/controllers/' . $url[0] . '.php')) {
            // если контроллер найден
            $this->controller = $url[0];
            unset($url[0]);
            
            require '../app/controllers/' . $this->controller . '.php';
            
            $this->controller = new $this->controller;
            
            /* Проверка на существование метода в контроллере*/
            if (isset($url[1])) {
                if (method_exists($this->controller, $url[1])) {
                    $this->method = $url[1];
                    unset($url[1]);
                }
            }
            
            $this->params = ($url ? array_values($url) : []);
            
            call_user_func_array([$this->controller, $this->method], $this->params);
            /* 
            P.S А если не находим, то подставляем по умолчанию из переменной $controller
            */
        }
        
    }
    
    public function parseUrl() {
        if (isset($_GET['url'])) {
            return $url = explode('/', filter_var(rtrim($_GET['url'], '/'), FILTER_SANITIZE_URL));
        }
    }
}